﻿// 選択されたポイントを、短くする。

//RunSclipt = confirm ("選択されたテキストを、登録情報を元に「漢字」→「かな」に置き換えます。\nスクリプトを実行しますか");

selobj = activeDocument.selection;
cutlength = 2;
//選択されたポイントを取得
// 2pt短くする。

for (var i = 0; i<selobj.length; i++){
    //選択アイテム分繰り返し
    if (selobj[i].typename == "PathItem"){
        //パスだった場合……
     
        //「選択されたパスの、起点と終点を取得、もし選択状態であれば、点の移動処理を行う」でどうだ？
        //という事で、まずは起点の処理
            if (selobj[i].pathPoints[0].selected == PathPointSelection.ANCHORPOINT) {
                
                    p0=selobj[i].pathPoints[0].anchor;
                     p1=selobj[i].pathPoints[1].anchor;
                        
                    ptpx=Math.abs(p0[0]-p1[0]);
                    ptpy=Math.abs(p0[1] -p1[1] );
                
                if (ptpx>ptpy){
                      //xの方が大きい場合
                        if (p0[0] >p1[0]){
                            p0[0] = p0[0] - cutlength;
                            }else{
                                p0[0] = p0[0] + cutlength;
                          }
                          if (p0[1] >p1[1] ){
                              
                            p0[1] = p0[1] - (cutlength * (ptpy/ptpx));
                            }else{
                             p0[1]=p0[1]+(cutlength* (ptpy/ptpx));
                          }
  
                 }else{
                     //yの方が大きい場合
                     if (p0[1] >p1[1]){
                            p0[1] = p0[1]- cutlength;
                            }else{
                                p0[1] = p0[1] + cutlength;
                          }
                          if (p0[0] >p1[0]){
                            p0[0] = p0[0] - (cutlength * (ptpx/ptpy));
                            }else{
                             p0[0]=p0[0]+(cutlength* (ptpx/ptpy));
                          }
                 }
                //変更後の数値を戻す

                selobj[i].pathPoints[0].anchor = p0 ;
                selobj[i].pathPoints[0].leftDirection = p0 ;
                selobj[i].pathPoints[0].rightDirection = p0 ;
            }
        //ポイントの位置を移動。次の点の座標も取得し、同じ角度で動かす。


        //終点の処理。呼び出すポイントの順番以外は同じでいいはず。
        var selpathlength =selobj[i].pathPoints.length;
        
            if ((selobj[i].pathPoints[selpathlength -1].selected == PathPointSelection.ANCHORPOINT)){
               
                    p0=selobj[i].pathPoints[selpathlength-1].anchor;
                    p1=selobj[i].pathPoints[selpathlength-2].anchor;
                        
                    ptpx=Math.abs(p0[0]-p1[0]);
                    ptpy=Math.abs(p0[1] -p1[1] );
                
                if (ptpx>ptpy){
                      //xの方が大きい場合
                        if (p0[0] >p1[0]){
                            p0[0] = p0[0] - cutlength;
                            }else{
                                p0[0] = p0[0] + cutlength;
                          }
                          if (p0[1] >p1[1] ){
                              
                            p0[1] = p0[1] - (cutlength * (ptpy/ptpx));
                            }else{
                             p0[1]=p0[1]+(cutlength* (ptpy/ptpx));
                          }
  
                 }else{
                     //yの方が大きい場合
                     if (p0[1] >p1[1]){
                            p0[1] = p0[1]- cutlength;
                            }else{
                                p0[1] = p0[1] + cutlength;
                          }
                          if (p0[0] >p1[0]){
                            p0[0] = p0[0] - (cutlength * (ptpx/ptpy));
                            }else{
                             p0[0]=p0[0]+(cutlength* (ptpx/ptpy));
                          }
                 }
                //変更後の数値を戻す

                selobj[i].pathPoints[selpathlength-1].anchor = p0 ;
                selobj[i].pathPoints[selpathlength-1].leftDirection = p0 ;
                selobj[i].pathPoints[selpathlength-1].rightDirection = p0 ;
                
          
             }

    }
//end for
}
// 起点・終点で同じ事をしているので、p0、p1を引数にして、移動距離を戻すサブルーチン化が出来るはず。
//もし2点の距離が短すぎる場合は点を削除する※未実装
//アンカーポイントが出ている場合、処理をスキップする。※未実装
//if(selobj[i].pathPoints[selpathlength -1].anchor == selobj[i].pathPoints[selpathlength -1].leftDirection){
//if((selobj[i].pathPoints[selpathlength -1].anchor == selobj[i].pathPoints[selpathlength -1].rightDirection)){